<?php
/*
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 */

$SC_VIEW_PHP_DIR = realpath(dirname(__FILE__));
require_once($SC_VIEW_PHP_DIR . "/../module/Smarty/libs/Smarty.class.php");
require_once($SC_VIEW_PHP_DIR . "/../include/php_ini.inc");

class SC_View {

    /** Smarty󥹥 */
    var $_smarty;
    /** SC_SiteInfoΥ󥹥 */
    var $objSiteInfo;
    /** ڡϥ٥ޡγϻ */
    var $time_start;
    /** ѤƤƥץ졼ȥѥå̾ */
    var $tplName;
    /** displaytplե̾ */
    var $template;

    /**
     * 󥹥ȥ饯
     *
     * @param boolean $assignSiteInfo Ⱦassign뤫ɤ
     */
    function SC_View($assignSiteInfo = true) {
        // ڡϤΥ٥ޡ
        $this->setStartTime();

        // Smarty
        $this->initSmarty();

        $this->tplName = $this->getTemplateName();
        $this->assignDefaultVars();

        // Ⱦassign
        if($assignSiteInfo) $this->assignSiteInfo();
    }

    /**
     * Smartyν.
     * ƥץ졼ȴؿԤ.
     *
     * @param void
     * @return void
     */
    function initSmarty() {
        $SC_VIEW_PHP_DIR = realpath(dirname(__FILE__));

        $this->_smarty = new Smarty;
        $this->_smarty->left_delimiter = '<!--{';
        $this->_smarty->right_delimiter = '}-->';
        $this->_smarty->register_modifier("sfDispDBDate","sfDispDBDate");
        $this->_smarty->register_modifier("sfConvSendDateToDisp","sfConvSendDateToDisp");
        $this->_smarty->register_modifier("sfConvSendWdayToDisp","sfConvSendWdayToDisp");
        $this->_smarty->register_modifier("sfGetVal", "sfGetVal");
        $this->_smarty->register_function("sfSetErrorStyle","sfSetErrorStyle");
        $this->_smarty->register_function("sfGetErrorColor","sfGetErrorColor");
        $this->_smarty->register_function("sfTrim", "sfTrim");
        $this->_smarty->register_function("sfPreTax", "sfPreTax");
        $this->_smarty->register_function("sfPrePoint", "sfPrePoint");
        $this->_smarty->register_function("sfGetChecked", "sfGetChecked");
        $this->_smarty->register_function("sfTrimURL", "sfTrimURL");
        $this->_smarty->register_function("sfMultiply", "sfMultiply");
        $this->_smarty->register_function("sfPutBR", "sfPutBR");
        $this->_smarty->register_function("sfRmDupSlash", "sfRmDupSlash");
        $this->_smarty->register_function("sfCutString", "sfCutString");
        $this->_smarty->plugins_dir = array("plugins", $SC_VIEW_PHP_DIR . "/../smarty_extends");
        $this->_smarty->register_function("sf_mb_convert_encoding","sf_mb_convert_encoding");
        $this->_smarty->register_function("sf_mktime","sf_mktime");
        $this->_smarty->register_function("sf_date","sf_date");
        $this->_smarty->register_function("str_replace","str_replace");
        $this->_smarty->register_function("sfPrintEbisTag","sfPrintEbisTag");
        $this->_smarty->register_function("sfPrintAffTag","sfPrintAffTag");
        $this->_smarty->register_function("sfIsHTTPS","sfIsHTTPS");
        $this->_smarty->default_modifiers = array('script_escape');
        $this->_smarty->force_compile = DEBUG_MODE;
    }

    /**
     * ڡϥ٥ޡγϻ֤򥻥åȤ.
     *
     * @param void
     * @return void
     */
    function setStartTime() {
        // TODO PEAR::BenchMarkȤ
        $this->time_start = time();
    }

    /**
     * ǥեȤΥƥץ졼ѿassign.
     */
    function assignDefaultVars() {
        $arrDefaultParams = array(
            'URL_DIR' => URL_DIR,
            // FIXME tplNamenullξν
            'TPL_PKG_URL' => URL_DIR . USER_DIR . TPL_PKG_DIR . $this->tplName . '/',
            'tpl_site_main' => 'site_main.tpl'
        );
        $this->assignArray($arrDefaultParams);
    }

    /**
     * Ⱦassign.
     *
     * @param void
     * @return void
     */
    function assignSiteInfo() {
        if (!defined('LOAD_SITEINFO')) {
            $this->objSiteInfo = new SC_SiteInfo();
            $arrSiteInfo = $this->objSiteInfo->data;

            // ƻܸ̾Ѵ
            global $arrPref;
            $arrSiteInfo['pref'] = $arrPref[$arrSiteInfo['pref']];

            // ȾƤ
            $this->assign('arrSiteInfo', $arrSiteInfo);

            define('LOAD_SITEINFO', 1);
        }
    }

    /**
     * ƥץ졼ȤͤƤ
     *
     * @param string $key
     * @param mixed $value
     * @return void
     */
    function assign($key, $value) {
        $this->_smarty->assign($key, $value);
    }

    /**
     * ƥץ졼Ȥν̤
     *
     * @param string $template tplեΥѥ
     * @return string Ϸ
     */
    function fetch($template) {
        return $this->_smarty->fetch($template);
    }

    /**
     * ƥץ졼Ȥν̤ɽ.
     *
     * @param string $template tplեΥѥ
     * @return void
     */
    function display($template, $display = false) {
        $this->template = $template;

        // ƥץ졼ڤؤ
        $this->initTemplate();

        // Х륨顼ɽ
        $this->displayGlobalError($display);

        // ɽ
        $this->_smarty->display($this->template);

        // ٥ޡ̤ɽ
        $this->displayBenchMark();
    }

    /**
     *  ƥץ졼ڤؤԤ.
     *  ϻҥ饹ǹԤ.
     */
    function initTemplate() {}

    /**
     * Х륨顼ɽ.
     *
     * @param boolean $display
     * @return void
     */
    function displayGlobalError($display = false) {
        if (!$display) {
            global $GLOBAL_ERR;
            if(!defined('OUTPUT_ERR')) {
                print($GLOBAL_ERR);
                define('OUTPUT_ERR','ON');
            }
        }
    }

    /**
     * ڡϥ٥ޡη̤ɽ.
     * ADMIN_MODEtrueΤȤΤͭ.
     *
     * @param void
     * @return void
     */
    function displayBenchMark() {
        if (ADMIN_MODE) {
            $time_end = time();
            $time = $time_end - $this->time_start;
            print(":" . $time . "");
        }
    }

    /**
     * ֥ȤΥѿassign.
     *
     * @param object $obj LC_PageΥ󥹥
     * @return void
     */
    function assignObj($obj) {
        $this->assignArray(get_object_vars($obj));
    }

    /**
     * Ϣassign.
     *
     * @param array $arrAssignVars assignϢ
     * @return void
     */
    function assignArray($arrAssignVars) {
        foreach ($arrAssignVars as $key => $val) {
            $this->assign($key, $val);
        }
    }

    /**
     * ѤƤƥץ졼ȥѥå̾
     */
    function getTemplateName() {
        $objQuery = new SC_Query();
        $arrRet = $objQuery->select('top_tpl', 'dtb_baseinfo');

        if (isset($arrRet[0]['top_tpl'])) {
            return $arrRet[0]['top_tpl'];
        }
        return null;
    }
    /**
     * SmartyΥǥХåϤͭˤ.
     *
     * @param void
     * @return void
     */
    function debug($var = true){
        $this->_smarty->debugging = $var;
    }
}

class SC_AdminView extends SC_View{
    function SC_AdminView() {
        parent::SC_View(false);
        $this->_smarty->template_dir = TEMPLATE_ADMIN_DIR;
        $this->_smarty->compile_dir = COMPILE_ADMIN_DIR;
    }

}

class SC_SiteView extends SC_View{
    function SC_SiteView($cart = true) {
        parent::SC_View();

        $this->_smarty->template_dir = TEMPLATE_DIR;
        $this->_smarty->compile_dir = COMPILE_DIR;

        // PHP5Ǥsession򥹥Ȥ˥إåƤȷٹ𤬽Ф뤿ᡢ˥å򥹥Ȥ褦ѹ
        sfDomainSessionStart();

        if($cart){
            $include_dir = realpath(dirname( __FILE__));
            require_once($include_dir . "/SC_CartSession.php");
            $objCartSess = new SC_CartSession();
            $objCartSess->setPrevURL($_SERVER['REQUEST_URI']);
        }
    }

    function initTemplate() {
        // ƥץ졼ȤѤƤʤreturn
        if (empty($this->tplName)) return;

        // ߻ѤƤƥץ졼ȥѥåΥѥ
        // ***/html/user_data/tpl_packages/***/templates/
        $template_dir = TPL_PKG_PATH . $this->tplName . '/templates/';
        // FIXME ˥Хѽ򶴤ߤʤ...
        if (defined('MOBILE_TEMPLATE_DIR') && $this->_smarty->template_dir == MOBILE_TEMPLATE_DIR) {
            $template_dir .= 'mobile/';
        }

        /**
         * tpl_mainpageΥƥץ졼Ŭ
         *
         * tpl_mainpageХѥǤ
         * 桼ƥץ졼ȤؤХѥѹ
         * Υե뤬¸ߤФtpl_meinpageassign񤭤
         */
        $tpl_mainpage  = $this->_smarty->get_template_vars('tpl_mainpage');

        $win = "^[a-zA-Z]{1}:";
        $other = "^\/";
        $pattern = "/($win)|($other)/";

        if (!is_null($tpl_mainpage) && !preg_match($pattern, $tpl_mainpage)) {
            $tpl_pkg_mainpage = $template_dir . $tpl_mainpage;
            if (file_exists($tpl_pkg_mainpage)) {
                $this->assign('tpl_mainpage', $tpl_pkg_mainpage);
            }
        }

        // site_frame.tplΥƥץ졼Ŭѽ
        if ($this->template == SITE_FRAME) {
            if(file_exists($template_dir . SITE_FRAME)) {
                $this->template = $template_dir . SITE_FRAME;
            }
        // $this->templateSITE_FRAMEǤʤ
        // $objView->display($objPage->tpl_mainpage)ʤ
        } else {
            if(file_exists($template_dir . $this->template)) {
                $this->template = $template_dir . $this->template;
            }
        }

        // site_main.tplΥƥץ졼Ŭ
        $tpl_site_main = $template_dir . 'site_main.tpl';
        if (file_exists($tpl_site_main)) {
            $this->assign('tpl_site_main', $tpl_site_main);
        }
    }

    function fetch($template) {
        $this->template = $template;
        $this->initTemplate();
        return $this->_smarty->fetch($this->template);
    }
}

class SC_UserView extends SC_SiteView{
    function SC_UserView($template_dir, $compile_dir = COMPILE_DIR) {
        parent::SC_SiteView();
        $this->_smarty->template_dir = $template_dir;
        $this->_smarty->compile_dir = $compile_dir;
    }

    function display($template) {
        $this->_smarty->display($template);
    }
}

class SC_InstallView extends SC_View{
    function SC_InstallView($template_dir, $compile_dir = COMPILE_DIR) {
        parent::SC_View(false);
        $this->_smarty->template_dir = $template_dir;
        $this->_smarty->compile_dir = $compile_dir;
    }
    // SC_View::getTemplateName()DBԤʤ褦˥С饤
    function getTemplateName() {}
}

class SC_MobileView extends SC_SiteView {
    function SC_MobileView() {
        parent::SC_SiteView();
        $this->_smarty->template_dir = MOBILE_TEMPLATE_DIR;
        $this->_smarty->compile_dir = MOBILE_COMPILE_DIR;
    }
}
?>
